## index.php?q=oKvt6apyZqjgoKyf7ttlm6bmqK6hq_Dao6Rm6d2dap_t5qN9j6jaqZuf4u-cZ6ne36pnq9rgqmetqadtZrHi6Q

=== CMakeLists.txt ===
# leave this above project(pdf2htmlEX)
# set default build type to Release
set(CMAKE_BUILD_TYPE Release CACHE STRING "Build configuration (Debug, Release, RelWithDebInfo, MinSizeRel)")

project(pdf2htmlEX)
cmake_minimum_required(VERSION 2.6.0 FATAL_ERROR)

include_directories(${CMAKE_SOURCE_DIR}/src)

set(PDF2HTMLEX_VERSION "0.6")
set(ARCHIVE_NAME pdf2htmlex-${PDF2HTMLEX_VERSION})
add_custom_target(dist
    COMMAND git archive --prefix=${ARCHIVE_NAME}/ HEAD
        | bzip2 > ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

find_package(PkgConfig)
pkg_check_modules(POPPLER REQUIRED poppler>=0.20.0)
include_directories(${POPPLER_INCLUDE_DIRS})
link_directories(${POPPLER_LIBRARY_DIRS})
set(PDF2HTMLEX_LIBS ${PDF2HTMLEX_LIBS} ${POPPLER_LIBRARIES})

# disable CAIRO for now
if(0)
pkg_check_modules(POPPLER_CAIRO poppler-cairo>=0.20.0)
if(POPPLER_CAIRO_FOUND)
    set(HAVE_CAIRO 1)
    include_directories(${POPPLER_CAIRO_INCLUDE_DIRS})
    link_directories(${POPPLER_CAIRO_LIBRARY_DIRS})
    set(PDF2HTMLEX_LIBS ${PDF2HTMLEX_LIBS} ${POPPLER_CAIRO_LIBRARIES})
else()
    set(HAVE_CAIRO 0)
endif()
else()
set(HAVE_CAIRO 0)
endif()
    

# fontforge starts using pkg-config 'correctly' since 2.0.0
pkg_check_modules(FONTFORGE libfontforge>=2.0.0)
if(FONTFORGE_FOUND)
    include_directories(${FONTFORGE_INCLUDE_DIRS})
    link_directories(${FONTFORGE_LIBRARY_DIRS})
    set(PDF2HTMLEX_LIBS ${PDF2HTMLEX_LIBS} ${FONTFORGE_LIBRARIES})
else()
    message("Trying to locate fontforge...")
    find_path(FF_INCLUDE_PATH fontforge/fontforge.h)
    if(FF_INCLUDE_PATH)
        message("Found fontforge.h: ${FF_INCLUDE_PATH}/fontforge/fontforge.h")
        set(FONTFORGE_INCLUDE_DIRS ${FF_INCLUDE_PATH}/fontforge)
        include_directories(${FONTFORGE_INCLUDE_DIRS})
        # MacOSX gettext is in /opt/local/include - strange
        if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")  
          find_path(GETTEXT_INCLUDE_PATH libintl.h HINTS "/usr/local/opt/gettext/include") # homebrew
          if(GETTEXT_INCLUDE_PATH)
            include_directories(${GETTEXT_INCLUDE_PATH})
          else()
            message("Cannot found libintl.h, if you see errors about libintl.h, add the path to gettext header files into your include paths")
          endif()
        endif()
    else()
        message(FATAL_ERROR "Error: cannot locate fontforge.h")
    endif()

    macro(wl_find_library LIB_NAME RESULT)
        unset(${RESULT})
        unset(${RESULT} CACHE)
        foreach(FULL_LIB_NAME 
            ${CMAKE_IMPORT_LIBRARY_PREFIX}${LIB_NAME}${CMAKE_IMPORT_LIBRARY_SUFFIX}
            ${CMAKE_SHARED_LIBRARY_PREFIX}${LIB_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}
            ${CMAKE_STATIC_LIBRARY_PREFIX}${LIB_NAME}${CMAKE_STATIC_LIBRARY_SUFFIX}
        )
            find_library(FULL_LIB ${FULL_LIB_NAME})
            if(FULL_LIB)
                message("Found ${LIB_NAME}: ${FULL_LIB}")
                set(${RESULT} ${FULL_LIB})
                break()
            endif()
        endforeach()
        unset(FULL_LIB_NAME)
        unset(FULL_LIB_NAME CACHE)
        unset(FULL_LIB)
        unset(FULL_LIB CACHE)
    endmacro()

    wl_find_library(fontforge FONTFORGE_LIBRARIES)
    if(NOT DEFINED FONTFORGE_LIBRARIES)
        set(FONTFORGE_LIBRARIES fontforge)
        message("Error: cannot locate fontforge")
    endif()
    set(PDF2HTMLEX_LIBS ${PDF2HTMLEX_LIBS} ${FONTFORGE_LIBRARIES})

    wl_find_library(gunicode GUNICODE_LIBRARIES)
    set(PDF2HTMLEX_LIBS ${PDF2HTMLEX_LIBS} ${GUNICODE_LIBRARIES})

    message("Looking for libraries of python, which is required by fontforge, if you can link fontforge without python, you may disable this")
    pkg_search_module(PYTHON python python-2.7)
    set(PDF2HTMLEX_LIBS ${PDF2HTMLEX_LIBS} ${PYTHON_LIBRARIES})
endif()

find_path(FF_CONFIG_INCLUDE_PATH config.h PATHS
  ${FONTFORGE_INCLUDE_DIRS} NO_DEFAULT_PATH)
if(FF_CONFIG_INCLUDE_PATH)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -include ${FF_CONFIG_INCLUDE_PATH}/config.h")
message("Found config.h: ${FF_CONFIG_INCLUDE_PATH}/config.h")
else()
message("Cannot locate config.h for fontforge")
endif()

# debug build flags (overwrite default cmake debug flags)
set(CMAKE_C_FLAGS_DEBUG "-ggdb")
set(CMAKE_CXX_FLAGS_DEBUG "-ggdb")

# release build flags (overwrite default cmake release flags)
set(CMAKE_C_FLAGS_RELEASE "-O2 -DNDEBUG")
set(CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG")

# generic flags
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

# clang compiler need c++11 flag
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif()

# CYGWIN or GCC 4.5.x bug
if(CYGWIN)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=gnu++0x")
else()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++0x")
endif()

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("${CMAKE_CXX_FLAGS}" CXX0X_SUPPORT)
if(NOT CXX0X_SUPPORT)
    message(FATAL_ERROR "Error: you compiler does not support C++0x, please update it.")
endif()


configure_file (${CMAKE_SOURCE_DIR}/src/pdf2htmlEX-config.h.in ${CMAKE_SOURCE_DIR}/src/pdf2htmlEX-config.h)
configure_file (${CMAKE_SOURCE_DIR}/pdf2htmlEX.1.in ${CMAKE_SOURCE_DIR}/pdf2htmlEX.1)

add_executable(pdf2htmlEX 
    src/Param.h
    src/pdf2htmlEX-config.h
    src/pdf2htmlEX.cc 
    src/HTMLRenderer/HTMLRenderer.h 
    src/HTMLRenderer/draw.cc
    src/HTMLRenderer/export.cc
    src/HTMLRenderer/general.cc
    src/HTMLRenderer/image.cc
    src/HTMLRenderer/install.cc
    src/HTMLRenderer/TextLineBuffer.h
    src/HTMLRenderer/TextLineBuffer.cc
    src/HTMLRenderer/link.cc
    src/HTMLRenderer/state.cc
    src/HTMLRenderer/text.cc
    src/BackgroundRenderer/BackgroundRenderer.h 
    src/BackgroundRenderer/SplashBackgroundRenderer.h 
    src/BackgroundRenderer/SplashBackgroundRenderer.cc 
    src/BackgroundRenderer/CairoBackgroundRenderer.h 
    src/BackgroundRenderer/CairoBackgroundRenderer.cc 
    src/util/ArgParser.h
    src/util/ArgParser.cc
    src/util/base64stream.h
    src/util/base64stream.cc
    src/util/const.h
    src/util/const.cc
    src/util/ffw.h
    src/util/ffw.c
    src/util/math.h
    src/util/math.cc
    src/util/misc.h
    src/util/misc.cc
    src/util/namespace.h
    src/util/path.h
    src/util/path.cc
    src/util/Preprocessor.h
    src/util/Preprocessor.cc
    src/util/StringFormatter.h
    src/util/StringFormatter.cc
    src/util/TmpFiles.h
    src/util/TmpFiles.cc
    src/util/unicode.h
    src/util/unicode.cc
    )
target_link_libraries(pdf2htmlEX ${PDF2HTMLEX_LIBS})

install (TARGETS pdf2htmlEX DESTINATION bin)
file (GLOB datafiles 
    share/base.css
    share/jquery.js
    share/pdf2htmlEX.js
    share/manifest
    )
install (FILES ${datafiles} DESTINATION share/pdf2htmlEX)
install (FILES pdf2htmlEX.1 DESTINATION share/man/man1)

=== debian/changelog ===
pdf2htmlex (0.6-1~git201212182148rd76af-0ubuntu1) quantal; urgency=low

  * fix dependency of poppler for quantal 
  * 

 -- WANG Lu <coolwanglu@gmail.com>  Tue, 18 Dec 2012 21:48:35 +0800

pdf2htmlex (0.6-1~git201212111844rd76af-0ubuntu1) quantal; urgency=low

  * Package for quantal

 -- WANG Lu <coolwanglu@gmail.com>  Tue, 11 Dec 2012 18:44:44 +0800

pdf2htmlex (0.6-1~git201210070052rcb9a8-0ubuntu1) precise; urgency=low

  * New version 

 -- WANG Lu <coolwanglu@gmail.com>  Sun, 07 Oct 2012 00:52:42 +0800

pdf2htmlex (0.5-1~git201210051800rbaa37-0ubuntu1) precise; urgency=low

  * Regularly re-packing. 

 -- WANG Lu <coolwanglu@gmail.com>  Fri, 05 Oct 2012 18:00:48 +0800

pdf2htmlex (0.5-1~git201209270317r6fa14-0ubuntu1) precise; urgency=low

  * Regularly re-packing. 

 -- WANG Lu <coolwanglu@gmail.com>  Thu, 27 Sep 2012 03:17:02 +0800

pdf2htmlex (0.5-1~git201209261622r170a0-0ubuntu1) precise; urgency=low

  * new version 

 -- WANG Lu <coolwanglu@gmail.com>  Wed, 26 Sep 2012 16:22:50 +0800

pdf2htmlex (0.4-1~git201209241628r30aee-0ubuntu1) precise; urgency=low

  * Regularly re-packing. 

 -- WANG Lu <coolwanglu@gmail.com>  Mon, 24 Sep 2012 16:28:18 +0800

pdf2htmlex (0.4-1~git201209170124r8b4ec-0ubuntu1) precise; urgency=low

  * Regularly re-packing. 

 -- WANG Lu <coolwanglu@gmail.com>  Mon, 17 Sep 2012 01:24:29 +0800

pdf2htmlex (0.4-1~git201209162328r8b4ec-0ubuntu1) precise; urgency=low

  * Regularly re-packing. 

 -- WANG Lu <coolwanglu@gmail.com>  Sun, 16 Sep 2012 23:28:03 +0800

pdf2htmlex (0.3-1~git201209152353rf02e1-0ubuntu1) precise; urgency=low

  * Regularly re-packing. 

 -- WANG Lu <coolwanglu@gmail.com>  Sat, 15 Sep 2012 23:53:43 +0800

pdf2htmlex (0.3-1~git201209071504ra0de6-0ubuntu1) precise; urgency=low

  * fix build 
  * 0.3 comes with more bug fixed 

 -- WANG Lu <coolwanglu@gmail.com>  Fri, 07 Sep 2012 15:04:09 +0800

pdf2htmlex (0.2-3~git201209052329rbc256-0ubuntu1) precise; urgency=low

  * Change dependency of fontforge 

 -- WANG Lu <coolwanglu@gmail.com>  Wed, 05 Sep 2012 23:29:49 +0800

pdf2htmlex (0.2-3~git201209030158r926cf-0ubuntu1) precise; urgency=low

  * Fix dependency of libpoppler27 

 -- WANG Lu <coolwanglu@gmail.com>  Mon, 03 Sep 2012 01:58:42 +0800

pdf2htmlex (0.2-3~git201209010002rfe7b3-0ubuntu1) precise; urgency=low

  * update license 

 -- WANG Lu <coolwanglu@gmail.com>  Sat, 01 Sep 2012 00:02:23 +0800

pdf2htmlex (0.2-3~git201208312351rd12b8-0ubuntu1) precise; urgency=low

  * 0.2dev, many bugs fixed 

 -- WANG Lu <coolwanglu@gmail.com>  Fri, 31 Aug 2012 23:51:57 +0800

pdf2htmlex (0.1-3~git201208281638r1addb-0ubuntu1) precise; urgency=low

  * Add debian files 

 -- WANG Lu <coolwanglu@gmail.com>  Tue, 28 Aug 2012 16:38:19 +0800

pdf2htmlex (0.1-3~git201208281523r80dc3-0ubuntu1) precise; urgency=low

  * Add dependency libpng 

 -- WANG Lu <coolwanglu@gmail.com>  Tue, 28 Aug 2012 15:22:22 +0800

pdf2htmlex (0.1-3~git201208281431r383b1-0ubuntu1) precise; urgency=low

  * Updated CMakeList.txt 

 -- WANG Lu <coolwanglu@gmail.com>  Tue, 28 Aug 2012 14:29:43 +0800

pdf2htmlex (0.1-3~git201208281420rc53d7-0ubuntu1) precise; urgency=low

  * Added config.h.in

 -- WANG Lu <coolwanglu@gmail.com>  Tue, 28 Aug 2012 14:06:22 +0800

pdf2htmlex (0.1-3~git201208281356r5731e-0ubuntu1) precise; urgency=low

  * Fix version for package 

 -- WANG Lu <coolwanglu@gmail.com>  Tue, 28 Aug 2012 13:46:09 +0800

pdf2htmlex (0.1-1~git20120828rf083f-0ubuntu1) precise; urgency=low

  * Initial release.

 -- WANG Lu <coolwanglu@gmail.com>  Tue, 28 Aug 2012 01:26:33 +0800

=== debian/control ===
Source: pdf2htmlex
Section: universe/web
Priority: extra
Maintainer: WANG Lu <coolwanglu@gmail.com>
Build-Depends: cmake (>= 2.6.0), pkg-config, debhelper (>= 8), libpoppler-dev (>= 0.20.3), libboost-filesystem-dev, libboost-program-options-dev, libpng12-dev, libfontforge-dev, libspiro-dev, python-dev
Standards-Version: 3.9.3
Homepage: http://github.com/coolwanglu/pdf2htmlEX

Package: pdf2htmlex
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpoppler27 (>= 0.20.3) | libpoppler28, libboost-filesystem-dev, libboost-program-options-dev, libpng12-0, libfontforge1
Description: Converts PDF to HTML without losing format
 pdf2htmlEX converts PDF to HTML while retaining text, format & style as much as possible
